/* 
** xfpovray icon image
**
** Robert Mallozzi
** mallozzir@cspar.uah.edu
**
*/

#version 3.0
global_settings { assumed_gamma 2.2 }

#include "colors.inc"
#include "metals.inc"
#include "textures.inc"
#include "axes.inc"
 
camera {
  location <-5, 4, -5>
  angle 50
  look_at <0, 0, 0>
}

light_source{<-10, 100, -60> color White }

  
#declare Link =
    torus { 1.0, 0.2 scale <2.0, 1.0, 1.0>
        texture { T_Chrome_5D }
    }
 
#declare Dlink = 
    union {
	object { Link 
            rotate <0, 0, 0>
            translate <0, 0, 0>
	}
	object { Link 
            rotate <90, 0, 0>
            translate <3.2, 0, 0>
	}
    }


#declare Chain = 
    union {

	object { Dlink
            translate <0, 0, 0>
            rotate <0, 0, 0>
	}
	#declare i=1
	#while (i<20)
            object { Dlink
        	translate <6.4*i, 0, 0>
            }
            #declare i=i+1
	#end

	#declare i=1
	#while (i<20)
            object { Dlink
        	translate <-6.4*i, 0, 0>
            }
            #declare i=i+1
	#end

    }

//object {
//    Axes
//}
object {Chain 
    rotate <0, 0, 0>
}
